<?php
/**
 * Clase Base FN para BaseCrLlamadasMovimientoFN
 *
 * @package    
 * @subpackage BaseCrLlamadasMovimientoFN
 * @author     Willy
 * @version    SVN:: BaseCrLlamadasMovimientoFN.class.php,v 1.1 2014-10-30 10:17:45 william.taype Exp $
 */
class BaseCrLlamadasMovimientoFN extends CrLlamadasMovimientoBN
{
  private static $fieldNames = array (
    'IdMovimientoLlamada'=>'IdMovimientoLlamada', 'IdCliente'=>'IdCliente', 'IdTelefono'=>'IdTelefono', 'Fecha'=>'Fecha'  
  );

  public function select()
  {
    try
    {
      $tamPag = !property_exists($this, 'tamPag')?9999:$this->tamPag;
      $pagina = !property_exists($this, 'page')||$this->page==""?1:$this->page;
      $numeroRegistros = $this->selectNumRows();
      $limitInf = ($pagina-1)*$tamPag;

      $where = $this->buildConsult();
      $orden = $this->buildOrderByField();

      $con = Conexion::getConexion();
      $sql = "SELECT IdMovimientoLlamada, IdCliente, IdTelefono, Fecha FROM cr_llamadas_movimiento WHERE 1 ".$where." ".$orden."  LIMIT ".$limitInf.",".$tamPag;
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
      $num_rows = mysql_num_rows($result);
      $a_tmp = array();
      if($num_rows>0){
        while ($o_valor = mysql_fetch_object($result)) {
          $a_tmp[] = $this->insertObjectBN($o_valor);
        }
      }
      
      return count($a_tmp)>0?$a_tmp:null;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  public function selectNumRows()
  {
    try
    {
      $where = $this->buildConsult();

      $con = Conexion::getConexion();
      $sql = "SELECT IdMovimientoLlamada, IdCliente, IdTelefono, Fecha FROM cr_llamadas_movimiento WHERE 1 ".$where;
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
      $num_rows = mysql_num_rows($result);
      
      return $num_rows;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  public function buildConsult()
  {
    try
    {
      $where = "";

      if($this->getIdMovimientoLlamada()){ $where .= " AND idmovimientollamada = '".$this->getIdMovimientoLlamada()."'"; }
      if($this->getIdCliente()){ $where .= " AND idcliente = '".$this->getIdCliente()."'"; }
      if($this->getIdTelefono()){ $where .= " AND idtelefono = '".$this->getIdTelefono()."'"; }
      if($this->getFecha()){ $where .= " AND fecha = '".$this->getFecha()."'"; }
      return $where;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  public function buildOrderByField()
  {
    try
    {
      $order_by = "";

      if(property_exists($this,'sortCampos')){
      if($this->sortCampos != ""){
        $a_valCampos = explode(";", $this->sortCampos);
        $a_valtype   = explode(";", $this->sortType);
        $order_by = " ORDER BY ";
        $a_order = array();
        foreach ($a_valCampos as $key => $val){
          $sTmpOrder = "";
          if(array_key_exists($val, self::$fieldNames)){
            $sTmpOrder .= self::$fieldNames[$val];
            switch ($a_valtype[$key]){
              case 1: $sTmpOrder .= " ASC"; break;
              case 2: $sTmpOrder .= " DESC"; break;
            }
            $a_order[] = $sTmpOrder;
          }
        }
        $order_by .= implode(", ", $a_order);
      }
      }
      return $order_by;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  /* Búsqueda del registro por la llave primaria */
  public function selectByPK()
  {
    try
    {
      $con = Conexion::getConexion();
      $sql = "SELECT IdMovimientoLlamada, IdCliente, IdTelefono, Fecha FROM cr_llamadas_movimiento WHERE 1 AND IdMovimientoLlamada='".$this->getIdMovimientoLlamada()."'; ";
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
      $o_Propel = $result ? mysql_fetch_object($result) : null;
      

      return $o_Propel?$this->insertObjectBN($o_Propel):null;

    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  /* Devuelve un objeto con métodos de acceso */
  private function insertObjectBN($o_propel){
    $o_BaseCrLlamadasMovimientoFN = new BaseCrLlamadasMovimientoFN();
    $o_BaseCrLlamadasMovimientoFN->setIdMovimientoLlamada($o_propel->IdMovimientoLlamada);
    $o_BaseCrLlamadasMovimientoFN->setIdCliente($o_propel->IdCliente);
    $o_BaseCrLlamadasMovimientoFN->setIdTelefono($o_propel->IdTelefono);
    $o_BaseCrLlamadasMovimientoFN->setFecha($o_propel->Fecha);
    return $o_BaseCrLlamadasMovimientoFN;
  }
}